/*****************************************************************************
 *
 * FILE:	functions.h
 * DESCRIPTION:	Cockatrice: functions declaration file
 * DATE:	Wed, Feb 14 2001
 * UPDATED:	Fri, Aug 24 2007
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2001-2007 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *
 *  Copyright (c) 2001-2007 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *   INTERRUPTION)  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *   THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: functions.h,v 1.4 2007/08/25 07:42:05 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_FUNCTIONS_H
#define	_FUNCTIONS_H

#ifdef	_COCKATRICE_H
/* param.c */
extern void		cc_param_init(void);
extern void		cc_param_finish(void);
extern int		cc_param_put(const char *, const char *);
extern const char *	cc_param_get(const char *);
extern VList *		cc_params_get(const char *);

/* cookie.c */
extern void	cc_cookie_init(void);
extern void	cc_cookie_finish(void);
extern void	cc_cookie_register_hooks(void);

/* upload.c */
extern int	cc_upload_init(void);
extern void	cc_upload_finish(void);
extern void	cc_upload_register_hooks(void);

/* module.c */
extern int	cc_load_module(const char *);
extern int	cc_unload_module(const char *);
extern int	cc_load_modules(int);
extern void	cc_initialize_modules(void);
extern void	cc_remove_modules(void);

/* util.c */
extern char *	cc_uri_escape(const char *);
extern char *	cc_uri_unescape(const char *);
extern char *	cc_chomp(char *);
extern char *	cc_digest_string(const char *, digest_t);
#if	ENABLE_ICONV || ENABLE_WKF
extern int	cc_conv_any2euc(const char * inbuf, size_t insize,
				char * outbuf, size_t outsize);
#endif
extern void	cc_utils_register_hooks(void);
#ifndef	HAVE_MKSTEMP
extern int	mkstemp(char *);
#endif	/* HAVE_MKSTEMP */

/* xwrap.c */
extern void *	cc_malloc(size_t);
extern void *	cc_calloc(size_t, size_t);
extern void *	cc_realloc(void *, size_t);
extern char *	cc_strdup(const char *);
#endif	/* _COCKATRICE_H */

#ifdef	_BASILISK_H
/* html20.c */
extern HTML *	newHTML20(void);

/* html32.c */
extern HTML *	newHTML32(void);
#endif	/* _BASILISK_H */

#ifdef	_CATOBLEPAS_H
/* html.c */
extern HTML *	newHTML401(dtd_t);
#endif	/* _CATOBLEPAS_H */

#endif	/* _FUNCTIONS_H */
